// $Id: TLdaAnlEvent.h 478 2009-10-29 12:26:09Z linev $
//-----------------------------------------------------------------------
//       The GSI Online Offline Object Oriented (Go4) Project
//         Experiment Data Processing at EE department, GSI
//-----------------------------------------------------------------------
// Copyright (C) 2000- GSI Helmholtzzentrum fr Schwerionenforschung GmbH
//                     Planckstr. 1, 64291 Darmstadt, Germany
// Contact:            http://go4.gsi.de
//-----------------------------------------------------------------------
// This software can be used under the license agreements as stated
// in Go4License.txt file which is part of the distribution.
//-----------------------------------------------------------------------

#ifndef TLdaANLEVENT_H
#define TLdaANLEVENT_H

#include "TGo4EventElement.h"
#include "TLdaInputDescription.h"
#include <TArrayI.h>

class TLdaAnlEvent : public TGo4EventElement {
   public:
      TLdaAnlEvent() ;
      TLdaAnlEvent(const char* name) ;
      virtual ~TLdaAnlEvent() ;
      virtual void  Clear(Option_t *t="");

      TArrayI phaseCounts[MAX_TDC];
      Double_t lasingAcc[MAX_SCA];//in Anl accumulated scaler counts in laser and DAQ lifetim
      Double_t eventMbsTime;//in absolute time
      Double_t eventUsefulLifeTime;//external clock during and laser lifetime
      Double_t whenSwitched;// in scaler (external) clock time
      Double_t cobraSetWL;
      Double_t atosAvgWL;
      Double_t lastAtosWL;
      Double_t lvAvgVal[TOTAL_LV_NUMBERS];
      Int_t	stepNr;
      char lmdName[100];
      ClassDef(TLdaAnlEvent,1)

};
#endif //TLdaANLEVENT_H



