// $Id: TLdaAnlProc.h 505 2009-11-05 18:03:50Z goofy $
//-----------------------------------------------------------------------
//       The GSI Online Offline Object Oriented (Go4) Project
//         Experiment Data Processing at EE department, GSI
//-----------------------------------------------------------------------
// Copyright (C) 2000- GSI Helmholtzzentrum fr Schwerionenforschung GmbH
//                     Planckstr. 1, 64291 Darmstadt, Germany
// Contact:            http://go4.gsi.de
//-----------------------------------------------------------------------
// This software can be used under the license agreements as stated
// in Go4License.txt file which is part of the distribution.
//-----------------------------------------------------------------------

#ifndef TLdaANLPROCESSOR_H
#define TLdaANLPROCESSOR_H

#include <TArrayI.h>
#include <TArrayL64.h>
#include <deque>
#include <map>
#include "TGo4EventProcessor.h"
#include "TLdaUnpackEvent.h"
#include "TGo4Parameter.h"
#include "TLdaInputDescription.h"
//#include "FixedQueue.h" 

//class FixedQueue;

class TLdaParameters;

class TLdaAnlEvent;

class TLdaAnlProc: public TGo4EventProcessor {
public:
	TLdaAnlProc();
	TLdaAnlProc(const char * name);
	virtual ~TLdaAnlProc();

	virtual Bool_t BuildEvent(TGo4EventElement* dest);

	TLdaParameters *fPar;

private:
    
    void Init();
    void InitSpectra();    
    void InitConditions();
    void InitLvSpectra();
    void Zero();
    void NormalizeHistorgams();
    
    void FillFixedDeque(std::deque< Long64_t >& myDeque, Long64_t value, const size_t max_size);
    
    enum{NORTH=5, MIDDLE=4, SOUTH=3, ANODE= 1, COPPER= 6, PART_SA=7, PART_NA=8, QSWITCH500US = 9, QSWITCH1MS = 10,  NORTH_GATED = 11, MIDDLE_GATED = 12,
        PDNO=13, PDSO = 14, QSWITCH = 15, SC1MHZ= 23, NEXTSTEP=31};    
    //enum{SC1MHZ= 23};
    
//    enum{ 
//        S_N=0,        //0
//        S_XUV=1,		// 1 	Analog, TDC
//        S_SOUTH=2,	// 2 	Analog, TDC
//        S_MIDDLE=3,	// 3 	Analog, TDC
//        S_NORTH=4,	// 4 	Analog, TDC
//        S_CU=5,		// 5 	Analog, TDC
//        S_1MHZ=6,      // 6
//        S_ALL=7     // 7 presently Middle and North
//    };
    
//    std::map<Int_t,Int_t> mPMTovWL[MAX_TDC];
//    std::map<Int_t,Int_t>::iterator it;
        
     TH1 *spStep[MAX_STEP];
//     TH1 *spStepN[MAX_STEP];  
     TH1 *spStepSig[MAX_STEP];   
//     TH1 *spStepSigN[MAX_STEP];
     


     TGo4WinCond* wcCondMaxCounts[MAX_STEP];
     TGo4WinCond* wcCondTDCSignal[MAX_STEP];
     Bool_t b1aCondMaxCounts[MAX_STEP];
     Bool_t b1aCondTDCSignal[MAX_STEP];   
     
     UInt_t testcounter1 =0;
     UInt_t testcounter2 =0; 
     
     UInt_t testtimer1 =0;
     UInt_t testtimer2 =0;



    // Bool_t b1a_TDCValid[MAX_TDC]; 
    Bool_t b1_ValidTDC;
     
    Double_t fPeriodInBins; // now set via Parameters....
   //tBin of Vuprom is 10/3 ns , 1/tBin = 3*1e8
    
    // periodInBins = 3e8 / 1.9518075e6;
   // periodInBins = 0.6*1e9/1.9518075e6/2; //nBunch / (rf * tBin);
    
 //   Bool_t b1a_scalValid[MAX_SCA];

    
//    Bool_t b1a_InTDCCondWindow[MAX_TDC];
    
    UInt_t uCounter;
    
	//Double_t scalSE[MAX_SCA];
	//Double_t tdcHitCount[MAX_TDC];
    // It is all Integer values, one should use again Integers	
    UInt_t scalSE[MAX_SCA];
	UInt_t tdcHitCount[MAX_TDC];
    
    Long64_t test;
    
    std::deque< Long64_t> deqCSQSwitch;    
    std::deque< Long64_t> deqCSQSwitch500us;    
    std::deque< Long64_t> deqCSQSwitch1ms;
    std::deque< Long64_t> deqCSPDSO;
    
    const size_t deqMAX=8;
    //    const size_t deqMAX=8;
    
	TArrayI tdcSE[MAX_TDC]; //TDC subevents
//	TArrayI tdcCSCounter[MAX_TDC];
    TArrayL64 tdcCSCounter[MAX_TDC];
//	TArrayI tsCS[MAX_TDC]; //timestamp common stop, same structure as tdcSE
	TArrayI tdcConvol[MAX_TDC];
//	TH1 *scalerHist[MAX_SCA];
	TH1 *scalerTrending[MAX_SCA];
	TH1 *dcTrafoTrending;
	TH1 *tdcTrending[MAX_TDC];
	TH1 *stackedTdcHist[MAX_TDC];
    
    TH1 *spTimeBetweenSteps;    
    TH1 *spTimeBetweenSteps2;
    Bool_t b1TestStep=kFALSE;
    
    Long64_t lStepTimer = 0;    
    Long64_t lStepTimerOld = 0;
    Long64_t lStepTimer2 = 0;  
    Long64_t lStepTimer2Old = 0;
    
    Long64_t iCSClockQswitch;
    UInt_t  uiHitQswitch;
    Long64_t iCSClockQswitch500us;     
    UInt_t  uiHitQswitch500us;
    Long64_t iCSClockQswitch1ms;     
    UInt_t  uiHitQswitch1ms;   
    Long64_t iCSClockQswitchPDSO;  
    UInt_t  uiHitQswitchPDSO;  
    
    Int_t iQswitchCountTemp = 0;
    Int_t iQswitchCountDiff = 0;
        
    Int_t iLaserStep = 0 ;      
    Int_t iLaserStepFromSetWaqvelength = 0;  
    Int_t iLaserScan = 0;
    Int_t iOldSetWaveLength;
    Int_t iSetWaveLength;
    Bool_t b1NewLaserStep; 
    
    const Int_t iLaserStepLow = 19; 
    const Int_t iLaserStepHigh = 29;

	TH1 *qSwitchInterval;
	TH1 *timeOfEventSec;
	TH1 *timeOfEventmSec;
	TH1 *deadTimeIntegral;
	TH1 *deadTimeNow;
	TH1 *missingTdcHits;
	TH1 *durationTrend;
	TH1 *sizeOfEvent;
    
 	//trending histograms for Labview data
	TH1 *lvTrending[MAX_SCA];
//	TH1 *pmtOverWavelength;
	

	TH1 *PMToverWavelengHist[MAX_TDC];
	TH1 *accumulatedTdcHist[MAX_TDC];
    TH1 *accusigTdcHist[MAX_TDC];    
    TH1 *accusigstepTdcHist[MAX_TDC];

	TH1 *agilentTrend;
	TH1 *uSetTrend;
	TH1 *ohmLabsTrend;
	TH1 *deviationTrendRead;
	TH1 *deviationTrendParam;
    
    TH1 *spTDCsize[MAX_TDC];
//      TH1			   *clockTimeHistFl;
//      TH1			   *mbsElapsedTimeHistFl;
	//      TH1			   *clockTimeHistRaw;

//      TH1			   *mbsElapsedTimeHistRaw;
	//Trending
    
    // Numbers should go to some 
    
    //Double_t pmtSignal; = trendAv[NORTH];	
	
	Double_t tdc_low = -0.5;
	Double_t tdc_high = 200.5;	
	Int_t tdc_div = 201;		

	Double_t time_low = 0.;
	Double_t time_high = 10000.;	
	Int_t time_div = 10000;			
	
	//Double_t wavelength_low = 320.0005;	// definitions for pmt over wavelength histogram	600.05
	//Double_t wavelength_high = 325.0005;	// definitions for pmt over wavelength histogram	650.05
	//Int_t wavelength_div = 2500;			// definitions for pmt over wavelength histogram	500 globals in input_description as they are avaiableevery_where

    //Don't use const here, walues will be overwritten using the paramters from SetParameters.C
    Double_t wavelength_low = 519.9975; //601-0.025	// definitions for pmt over wavelength histogram	600.05
	Double_t wavelength_high = 620.0025;	// definitions for pmt over wavelength histogram	650.05
	Int_t wavelength_div = 20001;	
    
//    const Double_t wavelength_low = 600.975; //601-0.025	// definitions for pmt over wavelength histogram	600.05
//	const Double_t wavelength_high = 602.025;	// definitions for pmt over wavelength histogram	650.05
//	const Int_t wavelength_div = 2001;		
    
    
    //Int_t wavelength_div = 2*67// definitions for pmt over wavelength histogram	500 globals in input_description as they are avaiableevery_where

    const Double_t uiStepsMin =-0.5;
    const Double_t uiStepsMax = 1000.5;
    const Int_t uiStepsDiv = 1001;
        
    const Double_t trend_scal_low = -0.5;
    const Double_t trend_scal_high = 7199.5; 	//before TREND_SCAL_HIGH, better use the		
    const Int_t trend_scal_div = 7200; 		//before TREND_SCAL_HIGH
    //Trending is in Seconds bins
    
//    Bool_t b1InQSWitchWindow;
    
	Double_t usefulLifeTime;
	Double_t lifeTimeClock;
	Double_t lastCl;
	Double_t lastSwitchTimeMbs;
	Double_t trendAv[MAX_SCA]; // accumulate here all scalers for trending till one second is over
	Double_t lasingAv[MAX_SCA]; // accumulate here all scalers for shipping during useful life (and lasing) time
	Double_t mbsStartTime;
	Double_t mbsTime;
	Double_t mbsTimeElapsed;
	Double_t lastMbsTime;
	Double_t timeSinceInj;
	Double_t lastInjTime;
	Double_t lastDead;
	ULong64_t timeLastQswInBins;
	ULong64_t timeLastQswInBinsOld;
	Int_t qSwExists;
	Int_t lastLvCalculatedStep;
	Int_t firstRun;
	Int_t lastEventCount;
    
    Int_t iChannel;
	ULong64_t mbsDataSize;
	Int_t ownEventCount;
	Int_t goFitting;
	Int_t timeAxisValue;
	Int_t ignoreInput;
	Int_t ignoreInputOld;
	Int_t Sig_low[MAX_TDC];
	Int_t Sig_high[MAX_TDC];
	Int_t Ref_low[MAX_TDC];
	Int_t Ref_high[MAX_TDC];
	
 //   Double_t IntegralValSigMinRef[MAX_TDC];
	
	// char
	char tmpPath[200];
	char tmpName[200];
	char tmpTitle[200];
	char tmpAxis[200];
	
	
	// Conditions
//	TGo4WinCond* stackedTdcCondSig[MAX_TDC];
//	TGo4WinCond* stackedTdcCondRef[MAX_TDC];

    //TGo4WinCond*    TestConditions;

	// for event preparation

	//to receive data from Labview server
	Long64_t trendLvAv[TOTAL_LV_NUMBERS]; // accumulate here all LabView data for trending till one second is over
	Long64_t trendLvCt[TOTAL_LV_NUMBERS];      // count how many occurences !=0
	Long64_t lasingLvAv[TOTAL_LV_NUMBERS]; // accumulate here all LabView data for shipping during useful life (and lasing) time
	Long64_t lasingLvCt[TOTAL_LV_NUMBERS];      // count how many occurences !=0
	Double_t lastCobraWL;
	Double_t lastAtosWL;
	Double_t atosAvgWL;



	ClassDef(TLdaAnlProc, 1)
};
#endif //TLdaANLPROCESSOR_H
