// $Id: TLdaParameter.h 506 2009-11-06 08:07:59Z linev $
//-----------------------------------------------------------------------
//       The GSI Online Offline Object Oriented (Go4) Project
//         Experiment Data Processing at EE department, GSI
//-----------------------------------------------------------------------
// Copyright (C) 2000- GSI Helmholtzzentrum fr Schwerionenforschung GmbH
//                     Planckstr. 1, 64291 Darmstadt, Germany
// Contact:            http://go4.gsi.de
//-----------------------------------------------------------------------
// This software can be used under the license agreements as stated
// in Go4License.txt file which is part of the distribution.
//-----------------------------------------------------------------------

#ifndef TLdaParameters_H
#define TLdaParameters_H

#include "TGo4Parameter.h"
#include "TLdaInputDescription.h"

class TLdaParameters : public TGo4Parameter {
   public:
      TLdaParameters();
      TLdaParameters(const char* name);
      virtual ~TLdaParameters();

      Int_t PrintParameter(Text_t * n=0, Int_t t=0);
      Bool_t UpdateFrom(TGo4Parameter *);
      
      ///// Paramters calculated from others
      
      
      ///// Paramters that can be updated during the run
      
      
      UShort_t  pusTimeAxisForLaserPulse;
      // 1 : use Qswtich
      // 2 : use PD_SO
      
      Double_t  pfUcool;
      Double_t  pfRevolutionFrequency;
      Int_t     piCSReductionFactor;
      Long64_t  piNOfCSForValidTimeRange;
      Int_t     piNOfLaserSteps;
      Double_t  pfSetWavelengthLow;
      Double_t  pfSetWavelengthHigh;
      Double_t  pfOhmlabsDividerRtatio;
      Int_t     piPhaseOffset;
      
      UShort_t pusFoldStepSpectra;
      Int_t    piLaserStep;
      
      //Double_t period; //[10ns/3] for convoluting
      //Int_t offset; //[10ns/3] for convoluting,

    ClassDef(TLdaParameters,1)

};

#endif
