// $Id: TLdaUnpackEvent.h 506 2009-11-06 08:07:59Z linev $
//-----------------------------------------------------------------------
//       The GSI Online Offline Object Oriented (Go4) Project
//         Experiment Data Processing at EE department, GSI
//-----------------------------------------------------------------------
// Copyright (C) 2000- GSI Helmholtzzentrum fr Schwerionenforschung GmbH
//                     Planckstr. 1, 64291 Darmstadt, Germany
// Contact:            http://go4.gsi.de
//-----------------------------------------------------------------------
// This software can be used under the license agreements as stated
// in Go4License.txt file which is part of the distribution.
//-----------------------------------------------------------------------

#ifndef TLdaEVENT_H
#define TLdaEVENT_H

#include <TArrayI.h>
#include "TGo4EventElement.h"
#include "TLdaInputDescription.h"
#include <time.h>
#include <TArrayL64.h>


class TLdaUnpackEvent: public TGo4EventElement {
public:
	TLdaUnpackEvent();
	TLdaUnpackEvent(const char* name);
	virtual ~TLdaUnpackEvent();

	/**
	 * Method called by the event owner (analysis step) to clear the
	 * event element.
	 */
	virtual void Clear(Option_t *t = "");
	//to receive data from Vuprom
	Int_t scalerSubEvent[MAX_SCA];	
    UInt_t eventLv[TOTAL_LV_NUMBERS];
    TArrayI tdcSubEvent[MAX_TDC];//According to Linevs advice. Dznamicallz allocated tdc hit vector, destroz properlz!
//	TArrayI arrTimeStampCS[MAX_TDC];//Analog zu Jonas Methode. Vermutlich oft die gleichen Eintrge
//    TArrayL64 arrCSCounter[MAX_TDC];
//	UInt_t timeStampCSEvent;//vermutlich geht hier Information verloren. Nur ein Wert pro Event bleibt erhalten.
//	Long64_t CSCounter[MAX_TDC];
    //TArrayI arrCSCounter[MAX_TDC];
    TArrayL64 arrCSCounter[MAX_TDC];
  
  
	//to receive data from header
	time_t eventTime;
	Int_t eventTimeMilliSec;
	Int_t eventCount;
	Int_t eventSizeMbs;
;

	//to receive data from Labview server


	ClassDef(TLdaUnpackEvent,1)
};
#endif //TLdaEVENT_H
