// $Id: TLda3aIntDiffEvent.h 478 2009-10-29 12:26:09Z linev $
//-----------------------------------------------------------------------
//       The GSI Online Offline Object Oriented (Go4) Project
//         Experiment Data Processing at EE department, GSI
//-----------------------------------------------------------------------
// Copyright (C) 2000- GSI Helmholtzzentrum fr Schwerionenforschung GmbH
//                     Planckstr. 1, 64291 Darmstadt, Germany
// Contact:            http://go4.gsi.de
//-----------------------------------------------------------------------
// This software can be used under the license agreements as stated
// in Go4License.txt file which is part of the distribution.
//-----------------------------------------------------------------------

#ifndef TLda3aIntDiffEvent_H
#define TLda3aIntDiffEvent_H

#include "TGo4EventElement.h"
#include "TLdaInputDescription.h"
#include <TArrayI.h>

class TLda3aIntDiffEvent: public TGo4EventElement {
public:
	TLda3aIntDiffEvent();
	TLda3aIntDiffEvent(const char* name);
	virtual ~TLda3aIntDiffEvent();
	virtual void Clear(Option_t *t = "");

	Int_t signal[MAX_TDC];
	Int_t signalAndBackground[MAX_TDC];
	Double_t lasingAcc[MAX_SCA];//in Anl accumulated scaler counts in laser and DAQ lifetim
	Int_t laser_switch;
	Int_t stepNr;
	Double_t atosAvgWL;
	Double_t lastAtosWL;
	Double_t cobraSetWL;
	Double_t eventMbsTime;//in absolute time
	Double_t eventUsefulLifeTime;//external clock during DAQ lifetime in sec
	Double_t lvAvgVal[TOTAL_LV_NUMBERS];
	char	lmdName[100];


ClassDef(TLda3aIntDiffEvent,1)
};
#endif //TLda3aIntDiffEvent_H

