// $Id: TLda3aIntDiffProc.h 505 2009-11-05 18:03:50Z goofy $
//-----------------------------------------------------------------------
//       The GSI Online Offline Object Oriented (Go4) Project
//         Experiment Data Processing at EE department, GSI
//-----------------------------------------------------------------------
// Copyright (C) 2000- GSI Helmholtzzentrum fr Schwerionenforschung GmbH
//                     Planckstr. 1, 64291 Darmstadt, Germany
// Contact:            http://go4.gsi.de
//-----------------------------------------------------------------------
// This software can be used under the license agreements as stated
// in Go4License.txt file which is part of the distribution.
//-----------------------------------------------------------------------

#ifndef TLda3bBunchFitPROCESSOR_H
#define TLda3bBunchFitPROCESSOR_H

#include <TArrayI.h>
#include "TGo4EventProcessor.h"
#include "TLdaUnpackEvent.h"
#include "TGo4Parameter.h"
#include "TLdaInputDescription.h"
#include "TLdaParameters.h"

class TLdaParameters;
class Parameter2ndList;
class TLda3bBunchFitEvent;

class TLda3bBunchFitProc : public TGo4EventProcessor {
   public:
	TLda3bBunchFitProc() ;
	TLda3bBunchFitProc(const char * name);
      virtual ~TLda3bBunchFitProc();

      virtual Bool_t BuildEvent(TGo4EventElement* dest);

      TLdaParameters     *fPar;
      Parameter2ndList	 *fPar2;
   private:
      Int_t				fittingCtr;
      Double_t			fitTime;//in scaler clock time
      Double_t			lastFitTime;
//      TH1              *convolutedTdcHist[MAX_TDC];
      TH1              *toBeFitted[MAX_TDC];
      TH1              *theFit[MAX_TDC];
      TH1              *fitAmpLong[MAX_TDC];
      TH1              *fitAmpShort[MAX_TDC];
      TH1              *fitAmpSignal[MAX_TDC];
      TH1              *uniformBackground[MAX_TDC];//alreadz normalized to total counts
      TH1              *fitTimeHist;
      TH1              *fitLifeTimeHist;




   ClassDef(TLda3bBunchFitProc, 1)
};
#endif //TLda3bBunchFitPROCESSOR_H
