// $Id: TLda4WaveMergProc.h 505 2009-11-05 18:03:50Z goofy $
//-----------------------------------------------------------------------
//       The GSI Online Offline Object Oriented (Go4) Project
//         Experiment Data Processing at EE department, GSI
//-----------------------------------------------------------------------
// Copyright (C) 2000- GSI Helmholtzzentrum fr Schwerionenforschung GmbH
//                     Planckstr. 1, 64291 Darmstadt, Germany
// Contact:            http://go4.gsi.de
//-----------------------------------------------------------------------
// This software can be used under the license agreements as stated
// in Go4License.txt file which is part of the distribution.
//-----------------------------------------------------------------------


//This step receives the signal strength of the previous step, calculates the wavelengths from the parameters and shows them.

#ifndef TLda4WaveMergProc_H
#define TLda4WaveMergProc_H

#include <TArrayD.h>
#include "TGo4EventProcessor.h"
#include "TLdaUnpackEvent.h"
#include "TGo4Parameter.h"
#include "TLdaInputDescription.h"
#include <iostream>
#include <fstream>

class TLdaParameters;
class Parameter2ndList;
class TLda4WaveMergEvent;

class TLda4WaveMergProc : public TGo4EventProcessor {
   public:
      TLda4WaveMergProc() ;
      TLda4WaveMergProc(const char * name);
      virtual ~TLda4WaveMergProc();

      virtual Bool_t BuildEvent(TGo4EventElement* dest);

      TLdaParameters     *fPar;
      Parameter2ndList	 *fPar2;

   private:
      TH1			   *intDiffScan[MAX_TDC];//only for current scan
      TArrayD			intDiffSig[MAX_TDC];//only for current scan
      TH1			   *intDiffAcc[MAX_TDC];//all scans, unnormalized
      TH1              *intDiffAccNorm[MAX_TDC];//for all analyzed scans
      TArrayD			intDiffSigNorm[MAX_TDC];//for all analyzed scans

      TH1			   *intTotalScan[MAX_TDC];//only for current scan
      TArrayD			intTotalSig[MAX_TDC];//only for current scan
      TH1			   *intTotalAcc[MAX_TDC];//all scans, unnormalized
      TH1              *intTotalAccNorm[MAX_TDC];//for all analyzed scans
      TArrayD			intTotalSigNorm[MAX_TDC];//for all analyzed scans

      TH1			   *fitScan[MAX_TDC];//only for current scan
      TArrayD			fitSig[MAX_TDC];//only for current scan
      TH1			   *fitAcc[MAX_TDC];//all scans, unnormalized
      TH1              *fitAccNorm[MAX_TDC];//for all analyzed scans
      TArrayD			fitSigNorm[MAX_TDC];//for all analyzed scans

      TH1			   *scalerScan[MAX_SCA];//only for current scan
      TArrayD			scalerSig[MAX_SCA];//only for current scan
      TH1			   *scalerAcc[MAX_SCA];//all scans, unnormalized
      TH1              *scalerAccNorm[MAX_SCA];//for all analyzed scans
      TArrayD			scalerSigNorm[MAX_SCA];//for all analyzed scans
      TH1			   *scalerG1minG3Scan;//purpose: coasting beam lock in
      TH1			   *scalerG1minG3Acc;//purpose: coasting beam lock in
      TH1			   *scalerG1minG3AccNorm;//purpose: coasting beam lock in

      TArrayD			stepToBinNo;
      TH1			   *lifeCurr;
      TH1			   *lifeAcc;
      TArrayD			usefulLifeTime;//sum up in each channel the useful life time in this channel

      Double_t			iIon;//DC-Trafo in mA calculated from the frequency with constants of TLdaInputDescription.h
      Int_t				hardwareGateSignal;
      Int_t				hardwareGateBackground;

      Int_t				LastLmdNr;
      std::ofstream 	outFile; //std:: was added on 01.12.2021
	  char				lastOutFileName[100];




   ClassDef(TLda4WaveMergProc, 1)
};
#endif //TLda4WaveMergProc_H
